--- ../vdr-1.3.10.save/menu.c	2004-06-06 17:06:28.000000000 +0200
+++ menu.c	2004-06-15 16:03:00.000000000 +0200
@@ -911,6 +911,7 @@
 
 cMenuWhatsOnItem::cMenuWhatsOnItem(const cEvent *Event, cChannel *Channel)
 {
+if (Event) {
   event = Event;
   channel = Channel;
   char *buffer = NULL;
@@ -921,6 +922,14 @@
   asprintf(&buffer, "%d\t%.*s\t%s\t%c%c%c\t%s", channel->Number(), 6, channel->Name(), event->GetTimeString(), t, v, r, event->Title());
   SetText(buffer, false);
 }
+else {
+  event = Event;
+  channel = Channel;
+  char *buffer = NULL;
+  asprintf(&buffer, "%d\t%.*s\t00:00\t\tKein EPG", channel->Number(), 6, channel->Name());
+  SetText(buffer, false);
+}
+}
 
 // --- cMenuWhatsOn ----------------------------------------------------------
 
@@ -951,6 +960,9 @@
             const cEvent *Event = Now ? Schedule->GetPresentEvent() : Schedule->GetFollowingEvent();
             if (Event)
                Add(new cMenuWhatsOnItem(Event, Channel), Channel->Number() == CurrentChannelNr);
+}         else {
+            const cEvent *Event = NULL;
+               Add(new cMenuWhatsOnItem(Event, Channel), Channel->Number() == CurrentChannelNr);
             }
          }
       }
@@ -969,7 +981,8 @@
 {
   cMenuWhatsOnItem *item = (cMenuWhatsOnItem *)Get(Current());
   if (item) {
-     cChannel *channel = Channels.GetByChannelID(item->event->ChannelID(), true);
+//     cChannel *channel = Channels.GetByChannelID(item->event->ChannelID(), true);
+     cChannel *channel = Channels.GetByNumber(item->channel->Number());
      if (channel && cDevice::PrimaryDevice()->SwitchChannel(channel, true))
         return osEnd;
      }
@@ -981,6 +994,7 @@
 {
   cMenuWhatsOnItem *item = (cMenuWhatsOnItem *)Get(Current());
   if (item) {
+  if (item->event) {
      cTimer *timer = new cTimer(item->event);
      cTimer *t = Timers.GetTimer(timer);
      if (t) {
@@ -988,7 +1002,7 @@
         timer = t;
         }
      return AddSubMenu(new cMenuEditTimer(timer, !t));
-     }
+     } }
   return osContinue;
 }
 
